/*
    sevensegment.c
    Copyright (C) 2014
    Authors: Arun I, Hari Prasad Gokul R 

    This file is part of Quiz Buzzer v2 firmware.

    Quiz Buzzer v2 firmware is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Quiz Buzzer v2 firmware is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Quiz Buzzer v2 firmware.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "sevensegment.h"

static void sevensegment_pinchange_hook(avr_irq_t* irq, uint32_t value, void* param);

void sevensegment_init(avr_t* avr, sevensegment_t* seg, uint8_t common, const char* name)
{
	seg->avr = avr;
	seg->common = common;
	seg->irq = avr_alloc_irq(&avr->irq_pool, 0, 1, &name);
	avr_irq_register_notify(seg->irq, sevensegment_pinchange_hook, seg);
}

static void sevensegment_pinchange_hook(avr_irq_t* irq, uint32_t value, void* param)
{
	sevensegment_t* seg = (sevensegment_t*)param;
	seg->value = value;
}
